<!-- ---------------------------------------------------------
  --
  -- Author: 1q74.tistory.com
  --
  --------------------------------------------------------- -->
<!doctype html>
<html lang="ko">
<head>
<meta charset="utf-8">
<title>[1q74.tistory.com] javascript/native/selector/attribute-contains</title>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
</head>
<body>

	<div name="_1q74-example-root">
		<div name="_1q74-example-1">
			<h4>Programming Language</h4>
			<li name="c">C</li>
			<li name="c++">C++</li>
			<li name="ada">Ada</li>
			<li name="lisp">Lisp</li>
			<li name="perl">Perl</li>
			<li name="python">Python</li>
			<li name="java">Java</li>
			<li name="javascript">JavaScript</li>
			<li name="go">Go</li>
			<li name="ruby">Ruby</li>
		</div>

		<div name="_1q74-example-bottom">
			<br/>
			<button name="btn-execute">#1. document.querySelectorAll("[name*='va']")</button>
		</div>
	</div>

	<hr/>
	<h5>[HTML Code]</h5>
	<div name="_1q74-source">
	</div>
	<h5>[//HTML Code]</h5>

<script>
// Example의 container을 얻는다.
var rootContainer = document.getElementsByName("_1q74-example-root")[0];

// 실행버튼을 얻는다.
var btnExecute = rootContainer.querySelector("[name='btn-execute']");

// 'va'가 들어간, 즉, 'java'라는 단어간 들어간 요소를 얻는다.
var languages = rootContainer.querySelectorAll("[name*='va']");

// 찾은 요소의 초기 텍스트를 저장한다.
languages["map"] = function(callback) {
	this["_result"] = [];

	for(let i = 0; i < this.length; i++) {
		this._result[i] = callback(i, this[i]);
	}

	return this;
}

languages["get"] = function() {
	return this._result;
}

var names = languages.map(function(i, el) {
	return el.textContent;
}).get();

// 찾은 요소들의 색상을 파랑으로 변경하고,
// 표시되는 텍스트에 문자열을 추가한다.
// (클릭한 횟수를 추가해서 보여준다.)
languages["each"] = function(callback) {
	for(let i = 0; i < this.length; i++) {
		callback(i, this[i]);
	}
}

var clickCount = 0;
btnExecute.addEventListener("click", function() {
	languages.each(function(index, element) {
		let addedText = " is great!!!";

		if(clickCount > 0) {
			addedText += "(" + clickCount + ")";
		}

		element.setAttribute("style", "color:blue;font-size:20px");
		element.textContent = names[index] + addedText;

	});

	++clickCount;
});

// ------------------------------------------------------
// 소스출력
// ------------------------------------------------------
var textSource = $("[name='_1q74-source']");
var exampleHtml = $("[name='_1q74-example-root']").html();
var specialCharLines = textSource.text(exampleHtml).html().split("\n");

textSource.html(specialCharLines.join("<br/>").replaceAll("\t", "&nbsp;&nbsp;"));
</script>
<style>
[name="_1q74-example-root"] {
	min-height: 350px;
}

[name="_1q74-example-1"] {
	min-height: 270px;
}

[name|="_1q74-example"] button
,[name="_1q74-source"] button {
	background: lightgray;
	border: 5px outset;
	min-height: 30px;
}

[name|="_1q74-example"] button:active
,[name="_1q74-source"] button:active {
	border: 2px inset;
	min-height: 30px;
}
</style>

</style>
</body>
</html>
